<script lang="ts">
  import { Alert, Label, Popover, Table } from 'sveltestrap';
  import { KeycloakStore } from '@auth/keycloak';
  import { Gql } from '../../db';

  import ConfigureModal from './components/ConfigureModal.svelte';
  import type { Challenge, ChallengeReturn } from '@models/Challenges';
  import { ChallengesQuery } from '@models/Challenges';
  import type { NullableEventRole } from '@auth/models';
  import { onMount } from 'svelte';
  import type { Color } from 'sveltestrap/src/shared';
  import { EventRole } from '@auth/models';

  let challenges: Challenge[] = [];
  let updateModalAlertMessage: string | null = null;
  let updateModalAlertColor: string = '';
  let totalPoints: number = 0;
  let configureModal: ConfigureModal;
  let queryRole: NullableEventRole;

  $: totalPoints = challenges.reduce(
    (total, allChall) => (total += allChall.active.reduce((activeTotal, active) => (activeTotal += active.points), 0)),
    0,
  );

  KeycloakStore.subscribe((value) => {
    queryRole = value.keycloak?.getFirstRole([EventRole.SuperAdmin, EventRole.CTFAdmin]);
  });

  const ChallengeSink = {
    complete: () => console.warn('Challenge Sink Completed'),
    error: (err: unknown) => console.error(err),
    next: (value: { data: ChallengeReturn }) => {
      challenges = value.data.challenges_challenges;
    },
  };

  onMount(() => {
    Gql.subscribe(`subscription ${ChallengesQuery}`, ChallengeSink, { role: queryRole });
  });

  const setUpdateModalAlert = (message: string, color: Color) => {
    updateModalAlertMessage = message;
    updateModalAlertColor = color;
  };
</script>

<div class="d-flex justify-content-center align-content-center m-3">
  <button
    type="button"
    on:click={() => configureModal.show()}
    class="btn btn-secondary btn-add-challenge"
    data-toggle="modal"
  >
    <i class="fa fa-flag" /> Add New Challenge
  </button>
  <Label class="m-3 align-self-center">Total Challenge Points (across all active events): {totalPoints}</Label>
</div>

<div class="container">
  <ConfigureModal
    onError={setUpdateModalAlert}
    onSuccess={async (msg) => setUpdateModalAlert(msg, 'success')}
    bind:queryRole
    bind:this={configureModal}
  />
</div>

<div>
  <Alert
    color={updateModalAlertColor}
    dismissible={true}
    isOpen={updateModalAlertMessage !== null}
    fade={true}
    toggle={() => {
      updateModalAlertMessage = null;
    }}
  >
    {updateModalAlertMessage}
  </Alert>
  {#if challenges?.length}
    <Table dark>
      <thead>
        <tr class="text-white">
          <th>Name</th>
          <th>Category</th>
          <th>Designer</th>
          <th>Description</th>
          <th class="text-truncate">Event Name</th>
          <th>Points</th>
          <th>Release Time</th>
          <th>Released</th>
          <th>Controls</th>
        </tr>
      </thead>
      <tbody>
        {#each challenges as challenge}
          {#each challenge.active.length > 0 ? challenge.active : [null] as activeChallenge}
            <tr class="text-white">
              <td>{challenge.name}</td>
              <td>{challenge.category}</td>
              <td>{challenge.designer}</td>
              <td class="text-truncate challenge-description">{challenge.description}</td>
              {#if activeChallenge}
                <td>{activeChallenge.event.name}</td>
                <td>{activeChallenge.points}</td>
                <td>{activeChallenge.release_time || 'Not Set'}</td>
                <td>
                  {#if activeChallenge.released}
                    <i class="fa fa-check text-success" />
                  {:else}
                    <i class="fa-solid fa-circle-xmark text-danger" />
                  {/if}
                </td>
              {:else}
                <td /> <td /> <td /> <td />
              {/if}

              <th>
                <div class="btn-group btn-group-sm">
                  <!-- TODO right align buttons -->
                  {#if activeChallenge}
                    <button
                      id={`pop-${challenge.id}_${activeChallenge.event.id}`}
                      type="button"
                      class="btn btn-secondary flag"
                      title=""
                    >
                      <i class="fa fa-flag" />
                    </button>
                    <Popover
                      class="text-white"
                      target={`pop-${challenge.id}_${activeChallenge.event.id}`}
                      placement="bottom"
                      animation
                    >
                      {#each activeChallenge?.flags.length > 0 ? activeChallenge.flags : [{ flag: 'NO FLAGS DEFINED' }] as flag}
                        <p>{flag.flag}</p>
                      {/each}
                    </Popover>
                  {/if}
                  <button
                    type="button"
                    on:click={() => configureModal.show(challenge)}
                    class="btn btn-warning btn-edit"
                  >
                    <i class="fa fa-pencil" />
                  </button>
                </div>
              </th>
            </tr>
          {/each}
        {/each}
      </tbody>
    </Table>
  {/if}
</div>

<style>
  .challenge-description {
    max-width: 200px;
    /* number of lines to show */
    -webkit-line-clamp: 3;
    line-clamp: 3;
  }

  .filelist tbody th:last-child {
    padding: 0 4px;
    vertical-align: middle;
  }

  .fileName {
    display: block;
    width: 100px;
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
  }
</style>
